<!-- Javascript for Domoticz frontpage -->
<!-- Create popup -->
function lightbox_open(id, timeout, txt){
    window.scrollTo(0,0);
        if (typeof txt != 'undefined') {
                $('#popup_'+id).html('<div>'+txt+'</div>'); }
        $('#popup_'+id).fadeIn('fast');
    $('#fade').fadeIn('fast');
        return setTimeout(function() {
            lightbox_close(id);
        }, timeout);
}
<!-- Close popup -->
function lightbox_close(id){
        $('#popup_'+id).fadeOut('fast');
        $('#fade').fadeOut('fast');
}

<!-- Main Frontpage fuction -->
function RefreshData()
{
        clearInterval($.refreshTimer);
        var jurl=$.domoticzurl+"/json.htm?type=devices&plan="+$.roomplan+"&jsoncallback=?";
        $.getJSON(jurl,
        {
                format: "json"
        },
        function(data) {
                if (typeof data.result != 'undefined') {

                        $.each(data.result, function(i,item){
                                for( var ii = 0, len = $.PageArray.length; ii < len; ii++ ) {
                                        if( $.PageArray[ii][0] === item.idx ) {         // Domoticz idx number
                                                var vtype=      $.PageArray[ii][1];             // Domotitcz type (like Temp, Humidity)
                                                var vlabel=     $.PageArray[ii][2];                     // cell number from HTML layout
                                                var vdesc=      $.PageArray[ii][3];                     // description
						var lastseen=   $.PageArray[ii][4];		//Display lastseen or noT
                                                var vplusmin=   $.PageArray[ii][5];             // minplus buttons
                                                var vattr=      $.PageArray[ii][6];                     // extra css attributes
                                                var valarm=     $.PageArray[ii][7];             // alarm value to turn text to red
                                                var vdata=      item[vtype];                            // current value
                                                var vstatus=    item["Status"];
						var vls=  item["LastUpdate"];			// ´Last Seen´

                                                var vdimmercurrent=  item["LevelInt"];  // What is the dim level
                                                if (typeof vdata == 'undefined') {
                                                        vdata="?!";
                                                        vdata=item.idx;
                                                } else {
                                                        // remove too much text
                                                        vdata=new String(vdata).split("Watt",1)[0];
                                                        vdata=new String(vdata).split("kWh",1)[0];
                                                        vdata=new String(vdata).split(" Level:",1)[0];
                                                        vdata=new String(vdata).replace("Set","On");
                                                        vdata=new String(vdata).split("m3",1)[0];
                                                        vdata=new String(vdata).replace("true","protected");
                                                }
                                                //Push On gives wrong(undesired) status
						if (item.SwitchType == 'Push On Button') {
                                                        vdata = 'Off'
                                                }

						//Check wether we want to add the last seen to the block
						if (lastseen == '1') {
							$('#ls_'+vlabel).html(vls)
						}
						else if (lastseen == '2' )
						{
							$('#ls_'+vlabel).html(sign_2)
						}

                                                // change background color, depending on sunset and sunrise using idx 37: virtual switch named IsDonker
                                                if(item.idx == idx_IsDonker && vdata == 'On'){
                                                        document.body.style.backgroundColor="#404040"   // night
                                                }
                                                if(item.idx == idx_IsDonker && vdata == 'Off'){
                                                        document.body.style.backgroundColor="#000000"   // day
                                                }

                                                if (vplusmin > 0) {
                                                        if (vstatus == 'Off') {
                                                        alarmcss=';color:#E24E2A;';
                                                        vdata = txt_off;
                                                }   else {
                                                        alarmcss=';color:#1B9772;';
                                                }}

                                                //Dimmer
                                                if(vplusmin > 0) {
                                                        if (vdata == txt_off) {
                                                                var hlp = '<span onclick="SwitchToggle('+item.idx+',\'On\')"; style='+alarmcss+'>'+ vdata+'</span>';
                                                                var plus = "<img src=icons/plus.png align=right vspace="+img_vspace+" width=50 onclick=ChangeStatus('plus',txt_off," + item.idx + ","+ vdimmercurrent+")>";
                                                                var min = "<img src=icons/min.png align=left vspace="+img_vspace+" width=50 onclick=ChangeStatus('min',txt_off," + item.idx + ","+ vdimmercurrent+")>"
                                                        }
                                                        else
                                                        {
                                                                var hlp = '<span onclick="SwitchToggle('+item.idx+',\'Off\')"; style='+alarmcss+'>'+ vdata+'</span>';
                                                                var plus = "<img src=icons/plus.png align=right vspace="+img_vspace+" width=50 onclick=ChangeStatus('plus'," + vdata + "," + item.idx + ","+ vdimmercurrent+")>";
                                                                var min = "<img src=icons/min.png align=left vspace="+img_vspace+" width=50 onclick=ChangeStatus('min'," + vdata + "," + item.idx + ","+ vdimmercurrent+")>"
                                                        }
                                                        vdata = min.concat(hlp,plus);
                                                        //console.log(vdata);
                                                }

                                                // replace forecast (text) with an image
                                                if (vdata == 'Sunny' ) {
                                                        vdata=new String(vdata).replace( "Sunny","<img src=icons/day_sun.png width=204 height=204>");
                                                }
                                                if (vdata == 'Partly Cloudy' ) {
                                                        vdata=new String(vdata).replace( "Partly Cloudy","<img src=icons/day-partlycloudy.png width=204 height=204>");
                                                }
                                                if (vdata == 'Cloudy' ) {
                                                        vdata=new String(vdata).replace( "Cloudy","<img src=icons/day-cloudy.png width=204 height=204>");
                                                }
                                                if (vdata == 'Clear' ) {
                                                        vdata=new String(vdata).replace( "Clear","<img src=icons/day_sun.png width=204 height=204>");
                                                }
                                                if (vdata == 'Rain' ) {
                                                        vdata=new String(vdata).replace( "Rain","<img src=icons/day-rain.png width=204 height=204>");
                                                }
                                                if (vdata == 'Snow' ) {
                                                        vdata=new String(vdata).replace( "Snow","<img src=icons/day-snow.png width=204 height=204>");
                                                }
                                                if (vdata == 'Fog' ) {
                                                        vdata=new String(vdata).replace( "Fog","<img src=icons/day-fog.png width=204 height=204>");
                                                }
                                                if (vdata == 'Hail' ) {
                                                        vdata=new String(vdata).replace( "Hail","<img src=icons/day-hail.png width=204 height=204>");
                                                }
                                                if (vdata == 'Thunderstom' ) {
                                                        vdata=new String(vdata).replace( "Thunderstorm","<img src=icons/day-thunder.png width=204 height=204>");
                                                }
                                                if (vdata == 'Sleet' )  {
                                                        vdata=new String(vdata).replace( "Sleet","<img src=icons/day-sleet.png width=204 height=204>");  
                                                }



                                                // create switchable value when item is switch
                                                switchclick='';
                                                alarmcss='';
                                                if (vdata == 'Off' ) {
                                                        switchclick = 'onclick="SwitchToggle('+item.idx+', \'On\');lightbox_open(\'switch\', '+switch_on_timeout+', '+txt_switch_on+')"';
                                                        alarmcss=';color:#E24E2A;';
                                                        vdata = txt_off;
                                                }
                                                if (vdata == 'On' ) {
                                                        switchclick = 'onclick="SwitchToggle('+item.idx+', \'Off\');lightbox_open(\'switch\', '+switch_off_timeout+', '+txt_switch_off+')"';
                                                        alarmcss=';color:#1B9772;';
                                                        vdata = txt_on;
                                                }

                                                // if alarm threshold is defined, make value red
                                                if (typeof valarm != 'undefined') {
                                                        alarmcss='';
                                                        if ( eval(vdata + valarm)) {  // note orig:  vdata > alarm
                                                                alarmcss=';color:red;';
                                                        }
                                                }

						// if extra css attributes. Make switch not switchable when it is protected, just give message.
						if (typeof vattr == 'undefined') {
							if (item.Protected == true) {
								$('#'+vlabel).html('<div onClick="lightbox_open(\'protected\', '+switch_protected_timeout+', '+txt_switch_protected+');" style='+alarmcss+'>'+vdata+'</div>');
							} else { 
								$('#'+vlabel).html('<div '+switchclick+' style='+alarmcss+'>'+vdata+'</div>');
							}
						} 
						else if (item.Protected == true) {
							$('#'+vlabel).html( '<div onClick="lightbox_open(\'protected\', '+switch_protected_timeout+ ', '+txt_switch_protected+');" style='+vattr+alarmcss+'>'+vdata+'</div>');
						} else {
							$('#'+vlabel).html( '<div '+switchclick+' style='+vattr+alarmcss+'>'+vdata+'</div>');
						}
//einde nieuw						


                                                $('#desc_'+vlabel).html(vdesc);
                                        }
                                        else if ( $.PageArray[ii][1] === 'Link' ) { //Special nummer, link in cell (test)
                                                //var vtype=    $.PageArray[ii][1];             // Domotitcz type (like Temp, Humidity)
                                                var vlabel=     $.PageArray[ii][2];             // cell number from HTML layout
                                                var vdata=      $.PageArray[ii][3];             // description (link in this case
                                                var vdesc = '';
                                                //var vattr=    $.PageArray[ii][6];             // extra css attributes
                                                var valarm=     $.PageArray[ii][7];             // alarm value to turn text to red
                                                //var vdata=    item[vtype];                            // current value

                                                $('#'+vlabel).html( '<div>'+vdata+'</div>');
                                                $('#desc_'+vlabel).html(vdesc);
                                        }
                                        else if ( $.PageArray[ii][1] === 'Tijd' ) { //Special nummer, tijd in cell (test)
                                                //var vtype=    $.PageArray[ii][1];             // Domotitcz type (like Temp, Humidity)
                                                var vlabel=     $.PageArray[ii][2];             // cell number from HTML layout
                                                var vdata=      currentTime();             	// Get present time
                                                var vdesc = '';
                                                var vattr=    $.PageArray[ii][5];             // extra css attributes
                                                var valarm=     $.PageArray[ii][6];             // alarm value to turn text to red
                                                //var vdata=    item[vtype];                            // current value

                                                $('#'+vlabel).html( '<div style='+vattr+'>'+vdata+'</div>');
                                                $('#desc_'+vlabel).html(vdesc);
						
					}
                                }
                        });
                }
        });

        var jurl=$.domoticzurl+"/json.htm?type=scenes&plan="+$.roomplan+"&jsoncallback=?";
        $.getJSON(jurl,
        {
                format: "json"
        },
        function(data) {
                if (typeof data.result != 'undefined') {

                        $.each(data.result, function(i,item){
                                for( var ii = 0, len = $.PageArray_Scenes.length; ii < len; ii++ ) {
                                        if( $.PageArray_Scenes[ii][0] === item.idx ) {          // Domoticz idx number
                                                var vtype=      $.PageArray_Scenes[ii][1];              // Domotitcz type (like Temp, Humidity)
                                                var vlabel=     $.PageArray_Scenes[ii][2];                      // cell number from HTML layout
                                                var vdesc=      $.PageArray_Scenes[ii][3];                      // description
                                                //var vattr=    $.PageArray_Scenes[ii][5];                      // extra css attributes
                                                var valarm=     $.PageArray_Scenes[ii][6];              // alarm value to turn text to red
                                                var vdata=      item[vtype];                            // current value
                                                if (typeof vdata == 'undefined') {
                                                        vdata="?!";
                                                } else {
                                                        // remove too much text
                                                        vdata=new String(vdata).split("Watt",1)[0];
                                                        vdata=new String(vdata).split("kWh",1)[0];
                                                }

                                                // create switchable value when item is scene
                                                switchclick='';
                                                alarmcss='';
                                                if (vdata == 'Off'  || vdata == 'Mixed' ) {
                                                        switchclick = 'onclick="SceneToggle('+item.idx+', \'On\');lightbox_open(\'switch\', '+switch_on_timeout+', '+txt_switch_on+')"';
                                                        alarmcss=';color:#E24E2A;';
                                                        vdata = txt_off;
                                                }
                                                if (vdata == 'On' ) {
                                                        switchclick = 'onclick="SceneToggle('+item.idx+', \'Off\');lightbox_open(\'switch\', '+switch_off_timeout+', '+txt_switch_off+')"';
                                                        alarmcss=';color:#1B9772;';
                                                        vdata = txt_on;
                                                }


                                                // if alarm threshold is defined, make value red
                                                if (typeof valarm != 'undefined') {
                                                        alarmcss='';
                                                        if ( eval(vdata + valarm)) {  // note orig:  vdata > alarm
                                                                alarmcss=';color:red;';
                                                        }
                                                }

                                                // if extra css attributes
                                                if (typeof vattr == 'undefined') {
                                                        $('#'+vlabel).html('<div '+switchclick+' style='+alarmcss+'>'+vdata+'</div>');
                                                } else {
                                                        $('#'+vlabel).html( '<div '+switchclick+' style='+vattr+alarmcss+'>'+vdata+'</div>');
                                                }

                                                $('#desc_'+vlabel).html(vdesc);
                                        }
                                }
                        });
                }
        });
        $.refreshTimer = setInterval(RefreshData, 8000);
}

//Switch state off a scene/group
function SceneToggle(idx, switchcmd)
{
         $.ajax({
     url: "json.htm?type=command&param=switchscene" + "&idx=" + idx + "&switchcmd=" + switchcmd + "&level=0",
     async: false,
     dataType: 'json',
     success: function(){
        console.log('SUCCES');
     },
     error: function(){
        console.log('ERROR');
     }
        });
        RefreshData();
}

//switch state of a switch
function SwitchToggle(idx, switchcmd)
{
         $.ajax({
     url: "json.htm?type=command&param=switchlight" + "&idx=" + idx + "&switchcmd=" + switchcmd + "&level=0",
     async: false,
     dataType: 'json',
     success: function(){
        console.log('SUCCES');
     },
     error: function(){
        console.log('ERROR');
     }
        });
        RefreshData();
}

//Dimmer, only works with 1-16 dimmer for now
function ChangeStatus(OpenDicht,level,idx,currentlevel)
{
//When switched off return to previous level, no matter if plus or min pressed
if (level == txt_off) {
	if (currentlevel == 1) {
		currentlevel++;
	}
	//console.log("In uit",currentlevel);
        $.ajax({
                url: "json.htm?type=command&param=switchlight&idx=" + idx + "&switchcmd=Set Level&level=" + currentlevel,
                async: false,
                dataType: 'json',
                success: function(){
                        console.log('SUCCES');

                },
                error: function(){
                        console.log('ERROR');
                }
        });
}
else
{
        level = level * 1;
        //console.log(OpenDicht,level);
        if (OpenDicht == "plus")
          {
                var d = ((level + 10)/100 * 16) +  0.5;
                if(d > 16) {
                        d = 16;
                }
                $.ajax({
                        url: "json.htm?type=command&param=switchlight&idx=" + idx + "&switchcmd=Set Level&level=" + d,
                        async: false,
                        dataType: 'json',
                        success: function(){
                                console.log('SUCCES');
                        },
                        error: function(){
                                console.log('ERROR');
                        }
                });
          }
          else
          {
                var d = ((level-0.1 )/100*16)  ;
                //console.log("in min",d,level);
                if( d < 0 ){
                        d = 0;
                }
                $.ajax({
                        url: "json.htm?type=command&param=switchlight&idx=" + idx + "&switchcmd=Set Level&level=" + d,
                        async: false,
                        dataType: 'json',
                        success: function(){
                                console.log('SUCCES');
                        },
                        error: function(){
                                console.log('ERROR');
                        }
                });
          }
        }
RefreshData();
}

//Return current time: dd-mm-yyyy hh:mm
function currentTime() {
    var today=new Date();
    var h=today.getHours().toString();
    h = h.trim();
    if (h.length == 1) { 
	h = '0'+ h;
    }
    var m=today.getMinutes().toString();
    m = m.trim();
    if (m.length == 1) { 
	m = '0'+ m;
    }
    var dag=today.getDate().toString();
    dag = dag.trim();
    if (dag.length == 1) { 
	dag = '0'+ dag;
    }
    var maand=(today.getMonth()+1).toString();
    maand = maand.trim();
    if (maand.length == 1) { 
	maand = '0'+ maand;
    }
    var jaar=today.getFullYear();
    var ret_str=dag+"-"+maand+"-"+jaar+" "+h+":"+m;
    return ret_str;
}

