<!-- Change the text for on/off switches -->
var txt_on = 'Aan';
var txt_off = 'Uit';

<!-- Change thetText displayed in PopUps -->
var txt_switch_protected = '\'Schakelaar is beveiligd\'';
var txt_switch_on = '\'Inschakelen\'';
var txt_switch_off = '\'Uitschakelen\'';

<!-- Change the timeout of the PopUp -->
var switch_protected_timeout = '1000';
var switch_on_timeout = '1000';
var switch_off_timeout = '1000';
var camera_doorbell_timeout = '15400';

<!-- Change idx of special items -->
var idx_IsDonker = '79'; //Use to detect if it is dark

var idx_water_meter = '380';
var idx_doorbell = '24';
var idx_electricity_today = '48';
var idx_gas_today = '49';
var idx_ram_usage = '1';
var idx_cpu_usage = '5';

<!-- This triggers the camera PopUp when the doorbell is pressed -->
<!-- Text could be 'On', 'Group On' or 'Chime' -->
var doorbell_status = 'On';


<!-- Global vars -->
var img_vspace=5;
var sign_2='%';

// ############################################################################################################
// #### vvvvv   USER VALUES below vvvvv   #######
// ############################################################################################################

$(document).ready(function() {
        $.roomplan=9;           // define roomplan in Domoticz and create items below.
        $.domoticzurl="http://192.168.1.2:8080";
        //format: idx, value, label, description,lastseen(1 when lastseen is wanted, 2 print %) ,plusmin button (1 for buttons), [override css], [alarm value]
        $.PageArray = [
                ['56','Status',         'cell6',                        'Lamp gang onder','0','0'],
                ['30','Status',         'cell1',                        'Eettafel','1','0'],
                ['35','Status',         'cell5',                        'Naar bed','0','0'],
                ['57','Level',          'cell13',                       'Lamp afdak (%)','2','1'],
                ['57','Status',         'cell14',                       'Lamp afdak','0','0'],
                ['15','Status',         'cell7',                        'Bijzettafel','0','0'],
                ['10','Status',         'cell11',                       'Feestverlichting','0','0'],
                ['19','Status',         'cell12',                       'Lampen tegen garage','0','0'],
                ['79','Status',         'cell00',                       'Donker switch','0','0'],
                ['8','Status',          'cell8',                        'Boekenkast','0','0'],
                ['17','Status',         'cell15',                       'Tuinlampen','0','0'],
                ['88','Status',         'cell9',                        'Naast Bank','0','0'],
                ['23','Status',         'cell21',                       'TV Slaapkamer','0','0'],
                ['73','Status',         'cell10',                       'Wijnrek','0','0'],
                ['26','Usage',          'cell16',                       'Huidig verbruik (Watt)','0','0'],
                ['78','Usage',          'cell19',                       'Actuele opwek (Watt)','0','0'],
                ['78','CounterToday',   'cell20',                       'Opwek vandaag (kWh)','0','0'],
                ['46','Temp',           'cell3',                        'Buiten Temperatuur (&deg;C)','0','0'],
                ['46','DewPoint',       'cell2_5',                      'Dauwpunt buiten (&deg;C)','0','0'],
                ['46','ForecastStr',    'cell25',                       'Weersvoorspelling','0','0'],
                ['0','Link',            'cell17',                       '<a href="http://www.nu.nl" target="_blank">NU.nl</a>','0','0'],
                ['0','Tijd',            'cell22',                       '','0','color:#17E213;font-size:150%'],
                ['47','Chill',          'cell23',                       'Gevoelstemp. (&deg;C)','0','0'],
                ['47','Speed',          'cell2_4',                      'Windsnelheid (m/s)','0','0'],
                ['6','Temp',            'cell2_6',                      'Temp. onder afdak (&deg;C)','0','0'],
                ['6','DewPoint',        'cell2_8',                      'Dauwpunt onder afdak (&deg;C)','0','0'],
                ['6','Humidity',        'cell2_7',                      'Vocht onder afdak (%) ','0','0'],
                ['39','Temp',           'cell2_16',                     'Temp. kelder(&deg;C)','0','0'],
                ['39','DewPoint',       'cell2_18',                     'Dauwpunt kelder(&deg;C)','0','0'],
                ['39','Humidity',       'cell2_17',                     'Vocht kelder(%) ','0','0'],
                ['38','Temp',           'cell2_11',                     'Temp. bijkeuken(&deg;C)','0','0'],
                ['38','DewPoint',       'cell2_13',                     'Dauwpunt bijkeuken(&deg;C)','0','0'],
                ['38','Humidity',       'cell2_12',                     'Vocht bijkeuken(%) ','0','0'],
                ['29','Tijd',           'cell2_1',                      '','0','color:#17E213;font-size:50%'],
                ['29','Status',         'cell2_2',                      'Ventilator bijkeuken','0','0'],
                ['69','Status',         'cell18',                       'Kerstmis','0','0'],
        ];
        $.PageArray_Scenes = [
                ['1','Status',  'cell4',                        'Avond thuis','0','0'],
                ['4','Status',          'cell2',                        'Tuinverlichting groep','0','0']
        ];

// ############################################################################################################
// #### ^^^^^   USER VALUES above ^^^^^   #######
// ############################################################################################################

RefreshData();
});


